#!/usr/bin/python
import sys
import vxi11
import time
import numpy as np

log_name = "dcl_10vdc_hulk_3458ab_nplc100.csv"

fluke = vxi11.Instrument("192.168.1.125", "gpib0,1") # Fluke 5720A, GPIB Address = 1
fluke.timeout = 30
#fluke.clear()
fluke.write("*IDN?")
print "Source detected = %s" % fluke.read()

dmm = vxi11.Instrument("192.168.1.125", "gpib0,3") # Keysight 3458A, GPIB Address = 1
dmm.timeout = 30
#dmm.clear()
#dmm.write("ID?")
#print "DUT1 detected = %s" % dmm.read()

dmm2 = vxi11.Instrument("192.168.1.125", "gpib0,2") # Keysight 3458A, GPIB Address = 1
dmm2.timeout = 30
#dmm2.clear()
#dmm2.write("ID?")
#print "DUT2 detected = %s" % dmm2.read()

fluke.write("RANGELCK OFF")
fluke.write("OUT 10.0 V, 0 Hz")
fluke.write("RANGELCK ON")
fluke.write("STBY")
fluke.write("OUT 0.0 V, 0 Hz")
fluke.write("EXTGUARD ON")
fluke.write("OPER")
time.sleep(2)
print "SRC configured"
dmm.write("BEEP")
dmm.write("END ALWAYS")
dmm.write("DCV 10")
dmm.write("NPLC 100")
dmm.write("NDIG 8")
dmm.write("TRIG AUTO")
dmm.write("MATH OFF")
print "DUT configured, starting ACAL"

dmm2.write("BEEP")
dmm2.write("END ALWAYS")
dmm2.write("DCV 10")
dmm2.write("NPLC 100")
dmm2.write("NDIG 8")
dmm2.write("TRIG AUTO")
dmm2.write("MATH OFF")
print "DUT2 configured, starting ACAL"

dmm.write("ACAL DCV")
dmm2.write("ACAL DCV")
time.sleep(160)
for vcnt in range (0,5):
    dmm.write("TARM SGL")
    dmm.read()
    dmm2.write("TARM SGL")
    dmm2.read()
dmm.write("MATH NULL")
dmm2.write("MATH NULL")
dmm.write("TARM SGL")
dmm.read()
dmm2.write("TARM SGL")
dmm2.read()
print "DUTs is nulled to MFC zero"

with open(log_name, 'a') as dile:
    dile.write ("date;source;duta;dutb;temp;temp2;\r\n")
dile.close()

vcnt = 0 # temporary counter
print "Log into %s started" % log_name

for i in range(-109,109,1):
    median = 0.0
    sdev = 0.0
    array = []
    median2 = 0.0
    sdev2 = 0.0
    array2 = []
    fluke.write("OUT %.7f" % (float(i) / 10))
    fluke.write("OPER")
    time.sleep(5)
    for ix in range (0,10): #take more samples
	dmm.write("TARM SGL")
	val = float(dmm.read())
	dmm2.write("TARM SGL")
	val2 = float(dmm2.read())
	array.extend([val])
	array2.extend([val2])
	if abs(float(i) / 10) >= 0.05:
	    print("\033[33;1mA sample = %.8f, ppmA dev %.4f \033[35;1mB sample = %.8f, ppmB dev %.4f \033[39;0m" % (val, ((val / (float(i)/10) - 1) * 1e6), val2,((val2 / (float(i)/10) - 1) * 1e6) ))
    	if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
	    print ("Smoke escaped, check connections")
	    fluke.write("OUT 0 V")
	    fluke.write("STBY")
	    quit()
    sdev = np.std(array[7:])
    median = np.median(array[7:])
    sdev2 = np.std(array2[7:])
    median2 = np.median(array2[7:])
    if abs(float(i) / 10) >= 0.05:
	dev1 = ((median / (float(i)/10) - 1) * 1e6)
	dev2 = ((median2 / (float(i)/10) - 1) * 1e6)
	print("\033[32;1mSRC %.2f \033[33;1mA %.9f, Asdev5 = %.3f uV, Amedian5 = %.8f\033[35;1mB %.9f, Asdev5 = %.3f uV, Amedian5 = %.8f \033[34;1m Delta %.4f ppm \033[39;0m" % (float(i)/10, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2) ))
        dmm.write("DISP MSG,'%5.3f %2.1fV" % (dev1,float(i)/10) )
        dmm2.write("DISP MSG,'%5.3f %2.1fV" % (dev2,float(i)/10) )
    dmm.write("TEMP?")
    temp = float(dmm.read())
    dmm2.write("TEMP?")
    temp2 = float(dmm2.read())
    with open(log_name, 'a') as dile:
        dile.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.2f;%.9f;%.9f;%.1f;%.1f;\r\n" % (float(i)/10, median, median2, temp, temp2)))
    dile.close()

fluke.write("OUT 0 V")
fluke.write("STBY")
fluke.write("RANGELCK OFF")
dmm.write("RESET")
dmm2.write("RESET")